package org.dromara.system.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.dromara.system.domain.bo.GameEventMenuBo;
import org.dromara.system.domain.vo.GameEventMenuVo;
import org.dromara.system.domain.GameEventMenu;
import org.dromara.system.mapper.GameEventMenuMapper;
import org.dromara.system.service.IGameEventMenuService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 基础菜单Service业务层处理
 *
 * @author zlt
 * @date 2025-08-01
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class GameEventMenuServiceImpl implements IGameEventMenuService {

    private final GameEventMenuMapper baseMapper;

    /**
     * 查询基础菜单
     *
     * @param menuId 主键
     * @return 基础菜单
     */
    @Override
    public GameEventMenuVo queryById(Long menuId){
        return baseMapper.selectVoById(menuId);
    }

    /**
     * 分页查询基础菜单列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 基础菜单分页列表
     */
    @Override
    public TableDataInfo<GameEventMenuVo> queryPageList(GameEventMenuBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<GameEventMenu> lqw = buildQueryWrapper(bo);
        Page<GameEventMenuVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的基础菜单列表
     *
     * @param bo 查询条件
     * @return 基础菜单列表
     */
    @Override
    public List<GameEventMenuVo> queryList(GameEventMenuBo bo) {
        LambdaQueryWrapper<GameEventMenu> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<GameEventMenu> buildQueryWrapper(GameEventMenuBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<GameEventMenu> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(GameEventMenu::getMenuId);
        lqw.eq(bo.getOrderNum() != null, GameEventMenu::getOrderNum, bo.getOrderNum());
        return lqw;
    }

    /**
     * 新增基础菜单
     *
     * @param bo 基础菜单
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(GameEventMenuBo bo) {
        GameEventMenu add = MapstructUtils.convert(bo, GameEventMenu.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setMenuId(add.getMenuId());
        }
        return flag;
    }

    /**
     * 修改基础菜单
     *
     * @param bo 基础菜单
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(GameEventMenuBo bo) {
        GameEventMenu update = MapstructUtils.convert(bo, GameEventMenu.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(GameEventMenu entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除基础菜单信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
